package org.dromara.work.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import org.dromara.work.domain.bo.TpUserRecordBo;
import org.dromara.work.domain.vo.TpUserRecordVo;
import org.dromara.work.domain.TpUserRecord;
import org.dromara.work.mapper.TpUserRecordMapper;
import org.dromara.work.service.ITpUserRecordService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 用户自己记录Service业务层处理
 *
 * @author Maosw
 * @date 2025-04-14
 */
@RequiredArgsConstructor
@Service
public class TpUserRecordServiceImpl implements ITpUserRecordService {

    private final TpUserRecordMapper baseMapper;

    /**
     * 查询用户自己记录
     *
     * @param id 主键
     * @return 用户自己记录
     */
    @Override
    public TpUserRecordVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询用户自己记录列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 用户自己记录分页列表
     */
    @Override
    public TableDataInfo<TpUserRecordVo> queryPageList(TpUserRecordBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<TpUserRecord> lqw = buildQueryWrapper(bo);
        Page<TpUserRecordVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的用户自己记录列表
     *
     * @param bo 查询条件
     * @return 用户自己记录列表
     */
    @Override
    public List<TpUserRecordVo> queryList(TpUserRecordBo bo) {
        LambdaQueryWrapper<TpUserRecord> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<TpUserRecord> buildQueryWrapper(TpUserRecordBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<TpUserRecord> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(TpUserRecord::getId);
        lqw.eq(bo.getUserId() != null, TpUserRecord::getUserId, bo.getUserId());
        lqw.like(StringUtils.isNotBlank(bo.getUserName()), TpUserRecord::getUserName, bo.getUserName());
        lqw.eq(StringUtils.isNotBlank(bo.getUserPhone()), TpUserRecord::getUserPhone, bo.getUserPhone());
        lqw.eq(bo.getType() != null, TpUserRecord::getType, bo.getType());
        lqw.eq(bo.getOrderId() != null, TpUserRecord::getOrderId, bo.getOrderId());
        lqw.eq(StringUtils.isNotBlank(bo.getOrderNum()), TpUserRecord::getOrderNum, bo.getOrderNum());
        lqw.eq(bo.getDelFlag() != null, TpUserRecord::getDelFlag, bo.getDelFlag());
        lqw.between(params.get("beginCreateTime") != null && params.get("endCreateTime") != null,
            TpUserRecord::getCreateTime ,params.get("beginCreateTime"), params.get("endCreateTime"));
        return lqw;
    }

    /**
     * 新增用户自己记录
     *
     * @param bo 用户自己记录
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(TpUserRecordBo bo) {
        TpUserRecord add = MapstructUtils.convert(bo, TpUserRecord.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改用户自己记录
     *
     * @param bo 用户自己记录
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(TpUserRecordBo bo) {
        TpUserRecord update = MapstructUtils.convert(bo, TpUserRecord.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(TpUserRecord entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除用户自己记录信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
